<?php
namespace Claromentis\Core\ORM\Behaviors;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"] = (@$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"] ?: array()) + array("met" . "ada" . "ta" => base64_decode("bWV0" . "YWRh" . "dGE="), "_7f628626dd1d55c71b1fc0932ffd" . "1d2c" => base64_decode("aXNf" . "YXJy" . "YXk="), "_c006f837e2824506391e3088" . "e0b02cea" => base64_decode("IG9yI" . "A=="), "_d5aab080ef90d0e0" . "aeec9b29c03836f2" => base64_decode("TWV0YWRhdGEgbXVzdCBiZSBhbiBhcnJheSBvZiBtZXRhZGF0YSB2Y" . "Wx1ZXMgb3IgYW4gaW5zdGFuY2Ugb2Yg"));
use Analogue\ORM\EntityCollection;
use Analogue\ORM\Mappable;
use Illuminate\Support\Collection;
use ProxyManager\Proxy\ProxyInterface;
use Claromentis\Core\ORM\Entity\Metadata as MetadataEntity;






















trait Metadata
{
    
    
    
    
    
    
    protected $metadata;
    
    
    
    
    
    
    public abstract function getMetadataAggregation() : int;
    
    
    
    
    
    
    public function getMetadataObjectId() : int
    {
        return $this->id;
    }
    
    
    
    
    
    
    public function getMetadataSetId() : int
    {
        return 0;
    }
    
    
    
    
    
    
    
    
    
    
    public function getMetadataAttribute($elements) : MetadataEntity
    {
        
        
        if (!$this->metadata) {
            $aggregation = $this->getMetadataAggregation();
            $object_id = $this->getMetadataObjectId();
            $set_id = $this->getMetadataSetId();
            $this->metadata = new MetadataEntity($this, $aggregation, $object_id, $set_id);
            $this->metadata->elements = $elements ?: new EntityCollection();
        }
        return $this->metadata;
    }
    
    
    
    
    
    
    
    
    
    public function setMetadataAttribute($metadata)
    {
        if (!$metadata instanceof MetadataEntity && !$metadata instanceof Collection && !$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_7f628626dd1d55c71b1fc0" . "932ffd1d2c"]($metadata)) {
            throw new \InvalidArgumentException($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_d5aab080e" . "f90d0e0aee" . "c9b29c0383" . "6f2"] . Collection::class . $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_c006f837e2824506" . "391e3088e0b02cea"] . MetadataEntity::class);
        }
        
        
        if ($metadata instanceof MetadataEntity) {
            $this->attributes[$GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["metadat" . "a"]] = $metadata->getElements()->flatten()->filter();
        }
        if ($metadata instanceof Collection) {
            $this->attributes[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["met" . "ada" . "ta"]] = $metadata->flatten()->filter();
        }
        
        
        if ($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_7f628626dd1" . "d55c71b1fc09" . "32ffd1d2c"]($metadata)) {
            $metadataEntity = $this->getMetadataAttribute(null);
            $metadataEntity->setValues($metadata);
        }
    }
}